import java.util.*;

public class Main {

    public static void main(String[] args) throws InvalidInputException {
        String test = "3.5 + 4 * 2 / ( 1 - 5 ) ^ 2 ^ 3 =";
        String testPostfix = "3.5 4 2 * 1 5 - 2 3 ^ ^ / + =";
        String[] tokens = RPNCalculatorUtil.parse(test);
        System.out.println(Arrays.toString(tokens));
        String[] res = RPNCalculatorUtil.transformInfixToPostfix(tokens);
        System.out.println(Arrays.toString(res));
        res = RPNCalculatorUtil.parse(testPostfix);
        RPNCalculator calculator = new RPNCalculator();
        double val = RPNCalculatorUtil.evaluatePostfixExpression(calculator, res);
        System.out.println(val);
    }
}
